react-semantic-ui
=================

[React](http://facebook.github.io/react/) components for [semantic-ui](http://semantic-ui.com/).  See [individual component docs](https://github.com/jhudson8/react-semantic-ui/tree/master/docs) for more details.

The purpose of this project is not to recreate every semantic-ui component but only where it makes sense and React components can add value.

* wrap up larger sets of HTML into a meaningful component
* if a component deals with user input where it can effictively manage state
* if a component can benefit from data driven properties to reneer itself in a dynamic way

Installation
==============
* Browser: include *react-semantic-ui[.min].js* after the listed dependencies
* CommonJS: ```global.rsui = require('react-semantic-ui')(require('react'));```

Dependencies
--------------
* [React](http://facebook.github.io/react/)
* [react-mixin-manager](https://github.com/jhudson8/react-mixin-manager)
* [semantic-ui](http://semantic-ui.com/) (browser only)


Examples
--------
See the [documentation](https://github.com/jhudson8/react-semantic-ui/tree/master/docs) for usage details

 - [Buttons](http://jhudson8.github.io/react-semantic-ui/examples/form/Button.html)
 - [Forms and Controls](http://jhudson8.github.io/react-semantic-ui/examples/form/FormAndControl.html)
 - [Basic Input Fields](http://jhudson8.github.io/react-semantic-ui/examples/input/BasicFields.html)
 - [Checkboxes](http://jhudson8.github.io/react-semantic-ui/examples/input/Checkbox.html)
 - [Dropdowns](http://jhudson8.github.io/react-semantic-ui/examples/input/Dropdown.html)
 - [RadioGroups](http://jhudson8.github.io/react-semantic-ui/examples/input/RadioGroup.html)
 - [Paginators](http://jhudson8.github.io/react-semantic-ui/examples/layout/Paginator.html)
 - [Menu](http://jhudson8.github.io/react-semantic-ui/examples/layout/Menu.html)
 - [Tabs](http://jhudson8.github.io/react-semantic-ui/examples/layout/Tabs.html)
 - [Tables](http://jhudson8.github.io/react-semantic-ui/examples/layout/Table.html)

